//+------------------------------------------------------------------+
//|                                                Volume trader.mq4 |
//|                                                       Ali Kazemi |
//|                                        http://www.ariandairy.com |
//+------------------------------------------------------------------+
#property copyright "Ali Kazemi"
#property link      "http://www.ariandairy.com"

//---- input parameters
extern string t1 ="2009,03,9 00:00";
extern string t2 ="2009,03,9 08:00";
extern string t3 ="2009,03,9 16:00";
extern string t4 ="2009,03,10 00:00";
extern string t5 ="2009,03,10 08:00";
extern string t6 ="2009,03,10 16:00";
extern int MA_Period=21;
extern int MA_Shift=0;
extern int MA_Method=1;
extern double LotSize=0.1;
extern int StopLoss=120;
double nearest_Array1[];
double nearest_Array2[];
double nearest_Array3[];
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
 int t1Yesterday=StrToTime(t1);
 int t2Yesterday=StrToTime(t2);
 int t3Yesterday=StrToTime(t3);
 int t1Today=StrToTime(t4);
 int t2Today=StrToTime(t5);
 int t3Today=StrToTime(t6);
 int Bar1Yest=iBarShift(NULL,0,t1Yesterday);
 int Bar2Yest=iBarShift(NULL,0,t2Yesterday);
 int Bar3Yest=iBarShift(NULL,0,t3Yesterday);
 int Bar1Today=iBarShift(NULL,0,t1Today);
 int Bar2Today=iBarShift(NULL,0,t2Today);
 int Bar3Today=iBarShift(NULL,0,t3Today);
 double firstz1Y=iCustom(NULL,0,"volumeMA",MA_Period,MA_Shift,MA_Method,2,Bar1Yest);
 double firstz2Y=iCustom(NULL,0,"volumeMA",MA_Period,MA_Shift,MA_Method,2,Bar2Yest);
 double firstz3Y=iCustom(NULL,0,"volumeMA",MA_Period,MA_Shift,MA_Method,2,Bar3Yest);
 double firstz1T=iCustom(NULL,0,"volumeMA",MA_Period,MA_Shift,MA_Method,2,Bar1Today);
 double firstz2T=iCustom(NULL,0,"volumeMA",MA_Period,MA_Shift,MA_Method,2,Bar2Today);
 double firstz3T=iCustom(NULL,0,"volumeMA",MA_Period,MA_Shift,MA_Method,2,Bar3Today);
 
 int  BarMaxz1Y=Bar1Yest;
      for(int i=Bar1Yest;i>Bar2Yest; i--){
       if((iCustom(NULL,0,"volumeMA",MA_Period,MA_Shift,MA_Method,2,i)) >firstz1Y){ 
       BarMaxz1Y=i;
       firstz1Y=iCustom(NULL,0,"volumeMA",MA_Period,MA_Shift,MA_Method,2,i);
       } 
     
 }

 int  BarMaxz2Y=Bar2Yest;
      for( i=Bar2Yest;i>Bar3Yest; i--){
       if((iCustom(NULL,0,"volumeMA",MA_Period,MA_Shift,MA_Method,2,i)) >firstz2Y){ 
       BarMaxz2Y=i;
       firstz2Y=iCustom(NULL,0,"volumeMA",MA_Period,MA_Shift,MA_Method,2,i);
       } 
     
 }
   int  BarMaxz3Y=Bar3Yest;
      for( i=Bar3Yest;i>Bar1Today; i--){
       if((iCustom(NULL,0,"volumeMA",MA_Period,MA_Shift,MA_Method,2,i)) >firstz3Y){ 
       BarMaxz3Y=i;
       firstz3Y=iCustom(NULL,0,"volumeMA",MA_Period,MA_Shift,MA_Method,2,i);
       } 
     
 }
    int  BarMaxz1T=Bar1Today;
      for( i=Bar1Today;i>Bar2Today; i--){
       if((iCustom(NULL,0,"volumeMA",MA_Period,MA_Shift,MA_Method,2,i)) >firstz1T){ 
       BarMaxz1T=i;
       firstz1T=iCustom(NULL,0,"volumeMA",MA_Period,MA_Shift,MA_Method,2,i);
       } 
     
 }
     int  BarMaxz2T=Bar2Today;
      for( i=Bar2Today;i>Bar3Today; i--){
       if((iCustom(NULL,0,"volumeMA",MA_Period,MA_Shift,MA_Method,2,i)) >firstz2T){ 
       BarMaxz2T=i;
       firstz2T=iCustom(NULL,0,"volumeMA",MA_Period,MA_Shift,MA_Method,2,i);
       } 
     
 }
 double c1=Close[BarMaxz1Y],c2=Close[BarMaxz2Y],c3=Close[BarMaxz3Y],c4=Close[BarMaxz1T],c5=Close[BarMaxz2Y];
Comment("close1=",c1);
double ask=MarketInfo(Symbol(),MODE_ASK); 
double bid=MarketInfo(Symbol(),MODE_BID);
 double a1=MathAbs(Open[0]-c1);
 double a2=MathAbs(Open[0]-c2);
 double a3=MathAbs(Open[0]-c3);
 double a4=MathAbs(Open[0]-c4);
 double a5=MathAbs(Open[0]-c5);
 double b1=Open[0]-c1;
 double b2=Open[0]-c2;
  double b3=Open[0]-c3;
   double b4=Open[0]-c4;
    double b5=Open[0]-c5;
if (Volume[0]>1){
return;
}
if (Time[0]==t1Today && a1<a2 && a1<a3 && Open[0]<c1){
OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,Ask-StopLoss*Point,c1,"BUY",16384,0,Green);
}
 if (Time[0]==t1Today && a1<a2 && a1<a3 && Open[0]>c1){
OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,Bid+StopLoss*Point,c1,"Sell",16384,0,Red);
}
 if (Time[0]==t1Today && a3>a2 && a3>a1 && Open[0]<c3){
OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,Ask-StopLoss*Point,c3,"BUY",16384,0,Green);
}
 if (Time[0]==t1Today && a3>a2 && a3>a1  && Open[0]>c3){
OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,Bid+StopLoss*Point,c3,"Sell",16384,0,Red);
}
 if (Time[0]==t1Today && a2>a1 && a2>a3 && Open[0]<c2){
OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,Ask-StopLoss*Point,c2,"BUY",16384,0,Green);
}
 if (Time[0]==t1Today && a1>a2 && a2>a3 && Open[0]>c2){
OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,Bid+StopLoss*Point,c2,"Sell",16384,0,Red);
}

if (Time[0]==t2Today && a2<a3 && a2<a4 && Open[0]<c2){
OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,Ask-StopLoss*Point,c2,"BUY",16384,0,Green);
}
if (Time[0]==t2Today && a2<a3 && a2<a4 && Open[0]>c2){
OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,Bid+StopLoss*Point,c2,"Sell",16384,0,Red);
}
if (Time[0]==t2Today && a3<a2 && a3<a4 && Open[0]<c3){
OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,Ask-StopLoss*Point,c3,"BUY",16384,0,Green);
}
if (Time[0]==t2Today && a3<a2 && a3<a4  && Open[0]>c3){
OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,Bid+StopLoss*Point,c3,"Sell",16384,0,Red);
}
if (Time[0]==t2Today && a4<a2 && a4<a3 && Open[0]<c4){
OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,Ask-StopLoss*Point,c4,"BUY",16384,0,Green);
}
if (Time[0]==t2Today && a4<a2 && a4<a3 && Open[0]>c2){
OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,Bid+StopLoss*Point,c2,"Sell",16384,0,Red);
}

if (Time[0]==t3Today && a3<a4 && a3<a5 && Open[0]<c3){
OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,Ask-StopLoss*Point,c3,"BUY",16384,0,Green);
}
if (Time[0]==t3Today && a3<a4 && a3<a5 && Open[0]>c3){
OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,Bid+StopLoss*Point,c3,"Sell",16384,0,Red);
}
if (Time[0]==t3Today && a4<a3 && a4<a5 && Open[0]<c4){
OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,Ask-StopLoss*Point,c4,"BUY",16384,0,Green);
}
if (Time[0]==t3Today && a4<a3 && a4<a5  && Open[0]>c4){
OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,Bid+StopLoss*Point,c4,"Sell",16384,0,Red);
}
if (Time[0]==t3Today && a5<a4 && a5<a3 && Open[0]<c5){
OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,Ask-StopLoss*Point,c5,"BUY",16384,0,Green);
}
if (Time[0]==t3Today && a5<a4 && a5<a3 && Open[0]>c5){
OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,Bid+StopLoss*Point,c5,"Sell",16384,0,Red);
}



   return(0);
  }
//+------------------------------------------------------------------+